/*
 *	cpu.h
 */

#ifndef	__CPU_H_
#define	__CPU_H_

/*
 *
 */

#define	ZERO_FLAG		(1<<0)
#define	NEGATIVE_FLAG	(1<<1)

/*
 *		C 言語では  x = x op y -> x op= y
 *			例 x = x + y -> x += y
 *			例 x = x | y -> x |= y
 */

#define	get_mask(cpup,mask)	((cpup -> flag) & mask)
#define	set_mask(cpup,mask)	((cpup -> flag) |= mask)
#define	clear_mask(cpup,mask)	((cpup -> flag) &= ~mask)

#define	get_zero(cpup)	get_mask(cpup,ZERO_FLAG)
#define	set_zero(cpup)	set_mask(cpup,ZERO_FLAG)
#define	clear_zero(cpup)	clear_mask(cpup,ZERO_FLAG)

#define	get_negative(cpup)	get_mask(cpup,NEGATIVE_FLAG)
#define	set_negative(cpup)	set_mask(cpup,NEGATIVE_FLAG)
#define	clear_negative(cpup)	clear_mask(cpup,NEGATIVE_FLAG)

/*
 *
 */

typedef	struct	{
  int	pc;
  int	acc;
  int	flag;
} CPU;

/*
 *
 */

extern	CPU *init_cpu ( CPU *cpup, int start );
extern	void execute ( CPU *cpup, int memory[], int debug );

/*
 *
 */


#endif

